This service will be undergoing maintenance at 00:00 UTC, 2016-08-01. It is expected to last about 1 hours
Bug 477418 - [linux-libertine-fonts] Please convert to new font packaging guidelines
[linux-libertine-fonts] Please convert to new font packaging guidelines
Status: CLOSED RAWHIDE
Product: Fedora
Classification: Fedora
Component: linux-libertine-fonts (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Kevin Fenzi
Fedora Extras Quality Assurance
: FutureFeature
: 490364 (view as bug list)
Depends On: 490364
Blocks: F11-new-font-rules
  Show dependency treegraph
 
Reported: 2008-12-20 19:32 EST by Nicolas Mailhot
Modified: 2011-02-17 06:38 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Enhancement
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2011-02-17 06:38:55 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Updated spec file (5.67 KB, text/x-rpm-spec)
2011-02-15 00:31 EST, Akira TAGOH
no flags Details
Updated fontconfig file for Linux Libertine fonts (695 bytes, text/plain)
2011-02-15 00:32 EST, Akira TAGOH
no flags Details
New fontconfig file for Linux Biolinum fonts (256 bytes, text/plain)
2011-02-15 00:33 EST, Akira TAGOH
no flags Details

  None (edit)
Description Nicolas Mailhot 2008-12-20 19:32:46 EST
This bug has been filed because we've detected your package includes one or several font files:                                                                                                                                                             repoquery -C --repoid=rawhide -f '*.ttf' -f '*.otf' -f '*.pfb' -f '*.pfa' --qf='%{SOURCERPM}\n' |sed -e 's+-[0-9.-]*\.fc[123456789]\(.*\)src.rpm++g'|sort|uniq                                                                                                                                                             Unfortunately the script does not detect symlinks to other packages, so if that's your case, you can close this bug report now.                                                                                                                                                              Otherwise, you should know that:                                                                                                                                                              - Fedora guidelines demand the packaging of fonts in a separate package or subpackage: http://fedoraproject.org/wiki/Packaging/Guidelines#Avoid_bundling_of_fonts_in_other_packages                                                                                - our font packaging guidelines recently changed, and every package that ships fonts must be adapted to the new templates available in the fontpackages-devel package. http://fedoraproject.org/wiki/PackagingDrafts/Fonts_packaging_automation_(2008-11-18) http://fedoraproject.org/wiki/Fedora_fonts_policy_package http://fedoraproject.org/wiki/Simple_fonts_spec_template http://fedoraproject.org/wiki/Fonts_spec_template_for_multiple_fonts                                                                                                                                                              Please make your package conform to the current guidelines in rawhide.                                                                                                                                                             If your package is not principaly a font package, depending on a separate font package or subpackage is the prefered solution. If your application does not use fontconfig you can always package symlinks to the files provided by the font package and installed in the correct fontconfig directories.                                                                                                                                                              It is preferred to make a font package or subpackage per font family, though it is not currently a hard guidelines requirement (it may become before Fedora 11 is released). The definition of a font family is given on http://fedoraproject.org/wiki/Fonts_spec_template_notes/font-family                                                                                                                                                              The new templates should make the creation of font subpackages easy and safe.                                                                                                                                                              The following packages have already been converted and can serve as examples: - andika-fonts - apanov-heuristica-fonts - bitstream-vera-fonts - charis-fonts - dejavu-fonts - ecolier-court-fonts - edrip-fonts - gfs-ambrosia-fonts - gfs-artemisia-fonts - gfs-baskerville-fonts - gfs-bodoni-classic-fonts - gfs-bodoni-fonts - gfs-complutum-fonts - gfs-didot-classic-fonts - gfs-didot-fonts - gfs-eustace-fonts - gfs-fleischman-fonts - gfs-garaldus-fonts - gfs-gazis-fonts - gfs-jackson-fonts - gfs-neohellenic-fonts - gfs-nicefore-fonts - gfs-olga-fonts - gfs-porson-fonts - gfs-solomos-fonts - gfs-theokritos-fonts - stix-fonts - yanone-kaffeesatz-fonts                                                                                                                                                           If you have any remaining questions about the new guidelines please ask them on fedora-fonts-list at redhat.com
Comment 1 Nicolas Mailhot 2008-12-20 19:56:15 EST
[Since the bot made a mess of the text here it is again in properly indented form.]

This bug has been filed because we've detected your package includes one or several font files:

repoquery -C --repoid=rawhide -f '*.ttf' -f '*.otf' -f '*.pfb' -f '*.pfa' --qf='%{SOURCERPM}\n' |sed -e 's+-[0-9.-]*\.fc[123456789]\(.*\)src.rpm++g'|sort|uniq

Unfortunately this script does not detect symlinks to other packages, so if that's your case, you can close this bug report now.

Otherwise, you should know that:

— Fedora guidelines demand the packaging of fonts in a separate package (or subpackage):
http://fedoraproject.org/wiki/Packaging/Guidelines#Avoid_bundling_of_fonts_in_other_packages

— our font packaging guidelines recently changed, and every package that ships fonts must be adapted to the new templates available in the fontpackages-devel package:
  – http://fedoraproject.org/wiki/PackagingDrafts/Fonts_packaging_automation_(2008-11-18)
  – http://fedoraproject.org/wiki/Fedora_fonts_policy_packagehttp://fedoraproject.org/wiki/Simple_fonts_spec_templatehttp://fedoraproject.org/wiki/Fonts_spec_template_for_multiple_fonts

Please make your package conform to the current guidelines in rawhide (you can use the fontpackages package in F9 or F10 to test, but only submit changes to rawhide please).

If your package is not principaly a font package, depending on a separate font package or subpackage is the prefered solution. If your application does not use fontconfig you can always package symlinks to the files provided by the font package and installed in the correct fontconfig directories.

It is preferred to create a font package or subpackage per font family, though it is not currently a hard guidelines requirement (it may become before Fedora 11 is released). The definition of a font family is given on:
http://fedoraproject.org/wiki/Fonts_spec_template_notes/font-family

The new templates should make the creation of font subpackages easy and safe.

The following packages have already been converted by their packager and can serve as examples:
❄ andika-fonts
❄ apanov-heuristica-fonts
❄ bitstream-vera-fonts
❄ charis-fonts
❄ dejavu-fonts
❄ ecolier-court-fonts
❄ edrip-fonts
❄ gfs-ambrosia-fonts
❄ gfs-artemisia-fonts
❄ gfs-baskerville-fonts
❄ gfs-bodoni-classic-fonts
❄ gfs-bodoni-fonts
❄ gfs-complutum-fonts
❄ gfs-didot-classic-fonts
❄ gfs-didot-fonts
❄ gfs-eustace-fonts
❄ gfs-fleischman-fonts
❄ gfs-garaldus-fonts
❄ gfs-gazis-fonts
❄ gfs-jackson-fonts
❄ gfs-neohellenic-fonts
❄ gfs-nicefore-fonts
❄ gfs-olga-fonts
❄ gfs-porson-fonts
❄ gfs-solomos-fonts
❄ gfs-theokritos-fonts
❄ stix-fonts
❄ yanone-kaffeesatz-fonts

If you have any remaining questions about the new guidelines please ask them on:
fedora-fonts-list at redhat.com
Comment 2 Nicolas Mailhot 2009-01-11 10:19:49 EST
To help packagers manage the transition to the new guidelines, we've published the following FAQ

http://fedoraproject.org/wiki/Shipping_fonts_in_other_packages_(FAQ)
Comment 3 Nicolas Mailhot 2009-01-14 13:37:24 EST
FPC approved those two additional guidelines recently, please take them into account if you need to create or update a fonts package or subpackage:

– 2009-01-14: naming
http://fedoraproject.org/wiki/PackagingDrafts/Font_package_naming_%282009-01-13%29

— 2009-01-06: exact splitting rules
http://fedoraproject.org/wiki/PackagingDrafts/Font_package_splitting_rules_%282008-12-21%29

(packagers that can drop font files and just depend on an existing font package are not impacted)
Comment 4 Nicolas Mailhot 2009-02-18 14:32:27 EST
This is a reminder for all the packagers that still have bugs open about adapting to font packaging guidelines there is only one month left before Fedora 11 beta:
http://fedoraproject.org/wiki/Releases/11/Schedule

A week of this month will see the Fedora 11 mass rebuild, that will load the build farm:
http://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

As already converted packages showed it is quite possible to make mistakes during the conversion. Please make releng and QA happy and don't wait till the last minute to do your changes (avoid pre-beta panic). If possible start before the mass rebuild so we don't burn cycles on incorrect packages.

The PackageKit enhancements stated for Fedora 11 assume fonts and font-using packages are sane (basically respect packaging guidelines). It is quite possible that not-converted packages will interact with the F11 font autoinstall feature in "interesting" ways.
http://fedoraproject.org/wiki/Features/AutomaticFontInstallation

We don't want that

There is extensive documentation on the wiki and most of your questions have likely already been answered there. Please do read the FAQ before making more work for the support team by asking questions answered there.
http://fedoraproject.org/wiki/Shipping_fonts_in_Fedora_%28FAQ%29
Comment 5 Rajeesh 2009-03-14 00:57:33 EDT
In the light of bug #477044:

This font spec needs the following modifications:

1. Add "%define	fontname  linux-libertine" at the top
2. Remove "%define fontdir" directive (at line 2)
3. Change "Name: linux-libertine-fonts" to "Name: %{fontname}-fonts"
4. Replace all the remaining "%{fontdir}" with "%{_fontdir}"
5. Replace the "%files" section completely with (No %files directive):

   %_font_pkg *.ttf
   %doc Readme *.txt
   %dir %{_fontdir}

Thanks!
Comment 6 Rajeesh 2009-03-14 01:40:26 EDT
Also,

6. Add "BuildRequires: fontpackages-devel > 1.13"
7. Remove both %post and %postun sections
Comment 7 Nicolas Mailhot 2009-03-15 14:55:54 EDT
%dir %{_fontdir} is not necessary anymore, too many people had problems with it, so the fedora macros were changed not to require it (at the expense of a minor directory ownership optimization)
Comment 8 Nicolas Mailhot 2009-03-30 15:37:38 EDT
*** Bug 490364 has been marked as a duplicate of this bug. ***
Comment 9 Nicolas Mailhot 2009-03-30 15:38:29 EDT
Also upstream has released a new major version. Was even featured on lwn.net
Comment 10 Bug Zapper 2009-06-09 06:23:09 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 11 development cycle.
Changing version to '11'.

More information and reason for this action is here:
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 11 Kevin Fenzi 2009-07-15 02:15:06 EDT
ok, I have checked in a 4.4.1-1 version to rawhide that I think works with all the current guidelines. Suggestions/review/comment on it welcome. 

If all looks well, I would like to push this to at least F11 as well. 

Sorry for the massive delay here. ;( 

See rawhide and/or: http://koji.fedoraproject.org/koji/taskinfo?taskID=1474651
Comment 12 Nicolas Mailhot 2009-07-15 04:20:57 EDT
(In reply to comment #11)

> If all looks well, I would like to push this to at least F11 as well. 

> See rawhide and/or: http://koji.fedoraproject.org/koji/taskinfo?taskID=1474651  

There is still some work to do :

1. linuxbiolinum and linuxlibertinec need to be split in their own subpackage (you should have only one font() autogenerated provide per package), each with its own fontconfig file

2. you should use 60 as priority for libertine (maybe 61 for the others if you don't think they're solid)

3. please take a look at
/usr/share/fontconfig/templates/substitution-font-template.*
to write correct fontconfig files
Biolinum needs to be registered as a sans-serif font
Libertine needs to be registered as a serif font, and declared as substitute for Times Roman and Times New Roman
Comment 13 Nicolas Mailhot 2009-07-15 04:22:17 EDT
Also it'd be great to move your build logic to a Makefile and have it merged upstream, this way upstream gets to make sure the correct fontforge options are used :p
Comment 14 Frank Arnold 2009-07-15 17:33:47 EDT
(In reply to comment #11)
> Sorry for the massive delay here. ;(

My fault, too. Sorry and thanks to Kevin.

(In reply to comment #12)
> There is still some work to do :

I don't think I can keep up with this stuff anymore. I'd be glad if someone with more insight would take over or at least is willing to co-maintain this package together with Kevin.

Some background: My current occupation has to do with QA of distributions, upstream KVM and Xen on specific processors and chipsets. Doing this stuff and getting it automated just eats too much time and brain... ;)

(In reply to comment #13)
> Also it'd be great to move your build logic to a Makefile and have it merged
> upstream.

I asked upstream some time ago to do this. He refused to do so and recommended to use his pre-built fonts, which goes against the Fedora ideal "everything has to be built from source".
Comment 15 Bug Zapper 2010-04-27 08:34:56 EDT
This message is a reminder that Fedora 11 is nearing its end of life.
Approximately 30 (thirty) days from now Fedora will stop maintaining
and issuing updates for Fedora 11.  It is Fedora's policy to close all
bug reports from releases that are no longer maintained.  At that time
this bug will be closed as WONTFIX if it remains open with a Fedora 
'version' of '11'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version prior to Fedora 11's end of life.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we may not be able to fix it before Fedora 11 is end of life.  If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora please change the 'version' of this 
bug to the applicable version.  If you are unable to change the version, 
please add a comment here and someone will do it for you.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: 
http://fedoraproject.org/wiki/BugZappers/HouseKeeping
Comment 16 Kevin Fenzi 2010-04-27 11:48:59 EDT
This still needs doing, and I have still failed to do it. ;( 

Help welcome, or I will try and get to it when I can.
Comment 17 Akira TAGOH 2011-02-15 00:31:00 EST
Created attachment 478761 [details]
Updated spec file

The changes made for:

* adding linux-libertine-biolinum-fonts for Linux Biolinum fonts
* adjusting the fontconfig priority
Comment 18 Akira TAGOH 2011-02-15 00:32:34 EST
Created attachment 478762 [details]
Updated fontconfig file for Linux Libertine fonts

The changes made for:

* adding the generic names rule
* adding the font substitution rules for Times Roman and times New Roman
* fixing the font substitution rule for Linux Libertine O
Comment 19 Akira TAGOH 2011-02-15 00:33:07 EST
Created attachment 478763 [details]
New fontconfig file for Linux Biolinum fonts
Comment 20 Kevin Fenzi 2011-02-15 00:42:14 EST
Wow. Once again this dropped off my radar. ;( 

Akira: Thanks so much for the changes. 

Would you be willing to co-maintain? if so, you could just commit your changes directly. 
we should probibly also upgrade to the newest version in rawhide/f15 at least (4.7.5). 

Feel free to apply in pkgdb and I will approve you... or if you would rather not, I can try and submit your changes and get some builds done.
Comment 21 Akira TAGOH 2011-02-17 06:38:55 EST
Fixed in linux-libertine-fonts-4.7.5-1.2.fc16.

Note You need to log in before you can comment on or make changes to this bug.